# !/usr/bin/env Python3
# -*- coding:utf-8 -*-
# Team:HiLab
# Author:Yu Tao
# Date:2022/7/1 15:22
# Tool:PyCharm
# Email:yuao_11260103@163.com
# Project:msDAWG
# ------ ------
# all datasets do feature selection use T-test Var
# ------ ------
import numpy as np
import sys
from datetime import datetime
from scripts.feature_select import *
from scripts.feature_decomposition import *
from scripts.evaluation import all_evaluate
from load_data import *

dt = datetime.today()
file_name = str(dt.day) + '-' + str(dt.hour) + '-' + str(dt.minute)
#
log_print = open(file_name + '.log', 'w')
sys.stdout = log_print
sys.stderr = log_print

datasets = ['HIP_CER', 'ICC_rms', 'SIMS', 'OvarianL91-162',
            'PanINDataH101-80',
            'OvarianL16-100-100',
            'JNCIL69-190-63']
for i in range(7):
    print(datasets[i])
    X = np.load('data/' + datasets[i] + '_X.npy')
    y = np.load('data/' + datasets[i] + '_y.npy', allow_pickle=True)
    X_train, y_train = get_train_data(i)
    X_test, y_test = get_test_data(i)
    data_dict = {'X_train': X,
                 'y_train': y,
                 'X_test': X,
                 'y_test': y}
    ranked_feature_index = shap_select(data_dict, X)

    precision_all = []
    recall_all = []
    acc_all = []
    auc_all = []
    feature_num = []
    for j in range(100, 501, 50):
        print(j)
        precision, recall, accuracy, aucc = all_evaluate(X_train[:, ranked_feature_index[:j]],
                                                         X_test[:, ranked_feature_index[:j]],
                                                         y_train,
                                                         y_test)
        feature_num.append(j)
        precision_all.append(precision)
        recall_all.append(recall)
        acc_all.append(accuracy)
        auc_all.append(aucc)
    best_feature_index = auc_all.index(max(auc_all))
    best_feature_num = feature_num[best_feature_index]
    best_feature_precision = precision_all[best_feature_index]
    best_feature_recall = recall_all[best_feature_index]
    best_feature_acc = acc_all[best_feature_index]
    best_feature_auc = auc_all[best_feature_index]
    selected_feature_index = ranked_feature_index[:best_feature_num]
    print('best_feature_num:', best_feature_num)
    print('best_feature_precision:', best_feature_precision)
    print('best_feature_recall:', best_feature_recall)
    print('best_feature_acc:', best_feature_acc)
    print('best_feature_auc:', best_feature_auc)
    print('selected_feature_index:', selected_feature_index)
    # precision_all = np.array(precision_all)
    # recall_all = np.array(recall_all)
    # acc_all = np.array(acc_all)
    # auc_all = np.array(auc_all)
    # feature_num = np.array(feature_num)
    #
    # precision_all = precision_all[None]
    # recall_all = recall_all[None]
    # acc_all = acc_all[None]
    # auc_all = auc_all[None]
    # feature_num = feature_num[None]
    # score = np.concatenate([feature_num, precision_all], axis=0)
    # score = np.concatenate([score, recall_all], axis=0)
    # score = np.concatenate([score, acc_all], axis=0)
    # score = np.concatenate([score, auc_all], axis=0)
    # np.savetxt('scores/' + datasets[i] + '_var.csv', score, delimiter=',', fmt='%.06f')
