# !/usr/bin/env Python3
# -*- coding:utf-8 -*-
# Team : HiLab
# Author：Yu Tao
# Date ：2022/6/20 20:18
# Tool ：PyCharm
# Email : yuao_11260103@163.com
# Project : msDAWG
from sklearn.decomposition import PCA, IncrementalPCA, KernelPCA
from sklearn.manifold import LocallyLinearEmbedding


def decomposition_PCA(data_dict, feat_n):
    """
    PCA

    :param data_dict
    :param feat_n:target feature number
    :return:X_selected -> arr :data after decomposition
    """
    print('-- start decomposition_PCA --')
    pca = PCA(feat_n)
    X_selected = pca.fit_transform(data_dict['X_train'])
    print('feature_num:', X_selected.shape[1])
    return X_selected


def decomposition_IPCA(data_dict, feat_n):
    """
    IPCA

    :param data_dict
    :param feat_n:target feature number
    :return:X_selected -> arr :data after decomposition
    """
    print('-- start decomposition_IncrementalPCA --')
    ipca = IncrementalPCA(feat_n)
    X_selected = ipca.fit_transform(data_dict['X_train'])
    print('feature_num:', X_selected.shape[1])
    return X_selected


def decomposition_KPCA(data_dict, feat_n):
    """
    KPCA

    :param data_dict
    :param feat_n:target feature number
    :return:X_selected -> arr :data after decomposition
    """
    print('-- start decomposition_KernelPCA --')
    kpca = KernelPCA(feat_n)
    X_selected = kpca.fit_transform(data_dict['X_train'])
    print('feature_num:', X_selected.shape[1])
    return X_selected


def decomposition_LLE(data_dict, feat_n):
    """
    LLE

    :param data_dict
    :param feat_n:target feature number
    :return:X_selected -> arr :data after decomposition
    """
    print('-- start decomposition_LLE --')
    lle = LocallyLinearEmbedding(n_components=feat_n)
    X_selected = lle.fit_transform(data_dict['X_train'])
    print('feature_num:', X_selected.shape[1])
    return X_selected
