# !/usr/bin/env Python3
# -*- coding:utf-8 -*-
# Team : HiLab
# Author：Yu Tao
# Date ：2022/6/20 20:58
# Tool ：PyCharm
# Email : yuao_11260103@163.com
# Project : msDAWG

from scipy.stats import levene
import numpy as np
from pandas import Series
from scipy.stats import ttest_ind
from scipy import stats
import warnings

warnings.filterwarnings("ignore")
def t_ranking(data, label):
    print('********************************************************')

    print('t_test')
    data_T = []
    data_N = []
    afterTtestValue = []
    for i in range(len(label)):
        if label[i] == 1:
            data_T.append(data[i])
        else:
            data_N.append(data[i])

    data_T = np.array(data_T)
    data_N = np.array(data_N)

    for i in range(len(data.T)):
        x = data_T[:, i]
        y = data_N[:, i]
        sx = Series(x)
        sy = Series(y)
        temp1 = levene(sx.astype(float), sy.astype(float))
        if temp1[1] > 0.05:
            temp2 = ttest_ind(sx.astype(float), sy.astype(float))
            afterTtestValue.append(temp2[1])
        else:
            temp2 = ttest_ind(sx.astype(float), sy.astype(float), equal_var=False)
            afterTtestValue.append(temp2[1])
    afterTtestValue = np.array(afterTtestValue)
    t_ranking_index = np.argsort(afterTtestValue)
    return t_ranking_index


def w_ranking(data, label):
    print('***********************************************************')

    print('w_test')
    data_T = []
    data_N = []
    afterWilTestValue = []
    for i in range(len(label)):
        if label[i] == 1:
            data_T.append(data[i])
        else:
            data_N.append(data[i])

    data_T = np.array(data_T)
    data_N = np.array(data_N)

    for i in range(len(data.T)):
        x = data_T[:, i]
        y = data_N[:, i]
        ax = set(x)
        ay = set(y)
        if (ax == ay) == True: continue
        sx = Series(x)
        sy = Series(y)
        afterWilTestValue.append(stats.mannwhitneyu(sx.astype(float), sy.astype(float))[1])

    afterWilTestValue = np.array(afterWilTestValue)
    w_ranking_index = np.argsort(afterWilTestValue)
    return w_ranking_index
