# !/usr/bin/env Python3
# -*- coding:utf-8 -*-
# Team:HiLab
# Author:Yu Tao
# Date:2022/7/5 17:01
# Tool:PyCharm
# Email:yuao_11260103@163.com
# Project:msDAWG
features_num = [400, 100, 100, 100, 200, 100, 200]  # shap
import numpy as np
import sys
from datetime import datetime
from scripts.feature_select import *
from scripts.feature_decomposition import *
from scripts.evaluation import all_evaluate
from load_data import *

datasets = ['HIP_CER', 'ICC_rms', 'SIMS', 'OvarianL91-162',
            'PanINDataH101-80',
            'OvarianL16-100-100',
            'JNCIL69-190-63']
for i in range(7):
    print(datasets[i])
    X = np.load('data/' + datasets[i] + '_X.npy')
    y = np.load('data/' + datasets[i] + '_y.npy', allow_pickle=True)
    X_train, y_train = get_train_data(i)
    X_test, y_test = get_test_data(i)
    data_dict = {'X_train': X,
                 'y_train': y,
                 'X_test': X,
                 'y_test': y}
    ranked_feature_index = shap_select(data_dict, X)
    selected_X_train = X_train[:, ranked_feature_index[:features_num[i]]]
    selected_X_test = X_test[:, ranked_feature_index[:features_num[i]]]
    print(selected_X_train.shape)
    print(selected_X_test.shape)
    np.save('data/shap_FS/' + datasets[i] + '_shap_train_X.npy', selected_X_train)
    np.save('data/shap_FS/' + datasets[i] + '_shap_test_X.npy', selected_X_test)

    # precision, recall, accuracy, aucc = all_evaluate(selected_X_train,
    #                                                  selected_X_test,
    #                                                  y_train,
    #                                                  y_test)
