# !/usr/bin/env Python3
# -*- coding:utf-8 -*-
# Team : HiLab
# Author：Yu Tao
# Date ：2022/6/26 18:53
# Tool ：PyCharm
# Email : yuao_11260103@163.com
# Project : msDAWG
# ------ ------
# split dataset to 8-2 train-test and save as .npy file
# ------ ------

from load_data import *
from scripts.feature_select import *
from datetime import datetime
import sys

dt = datetime.today()
file_name = str(dt.day) + '-' + str(dt.hour) + '-' + str(dt.minute)

log_print = open(file_name + '.log', 'w')
sys.stdout = log_print
sys.stderr = log_print
datasets = ['HIP_CER', 'ICC_rms', 'SIMS', 'OvarianL91-162',
            'PanINDataH101-80',
            'OvarianL16-100-100',
            'JNCIL69-190-63']
for i in range(7):
    print(datasets[i])
    X = np.load('data/' + datasets[i] + '_X.npy')
    y = np.load('data/' + datasets[i] + '_y.npy', allow_pickle=True)
    print(X.shape)
    print(y.shape)
    X_train, X_test, y_train, y_test = split_train_test(X, y)
    print(X_train.shape)
    print(X_test.shape)
    print(y_train.shape)
    print(y_test.shape)
    np.save('data/82split/' + datasets[i] + '_train_X.npy', X_train)
    np.save('data/82split/' + datasets[i] + '_test_X.npy', X_test)
    np.save('data/82split/' + datasets[i] + '_train_Y.npy', y_train)
    np.save('data/82split/' + datasets[i] + '_test_Y.npy', y_test)

